clc;clear;

Root = 'data';

addpath(genpath('./'));
data={'NUS'};
dataPath = strcat('./',Root,'/');
name='norm';
maxIter = 20;

funName = 'AccSMUFS';

fprintf('Training %s\n',funName);


for dataIndex = 1:length(data)
    dataName = strcat(data{dataIndex}); disp(dataName);
    load(strcat(dataPath,dataName));

    C = length(unique(Y));
    viewNumber = length(X);
    N = size(X{1},1);
    m = size(Z{1},1);
    neighbor = m/2;

    Ball = zeros(N,m);

    totalFeatureNumber=0;
    Xall = [];

    for v = 1:viewNumber
        totalFeatureNumber=totalFeatureNumber+size(X{v},2);
        B{v} = constructW_PKN(X{v}', Z{v}', neighbor, 0);
        Xall = [Xall,X{v}];
        Ball = Ball + B{v}/viewNumber;
    end

    %% Parameter setting
    lambda = 1e3;
    gamma = 1e3;
    FeatureNumber = floor(0.10*totalFeatureNumber);


    %% Training
    fprintf('Now iter:lambda %f gamma %f FeatureNumber %f \n',lambda, gamma, FeatureNumber);
    [W,~] = AccSMUFS(Xall', U, Ball, lambda, gamma, FeatureNumber, neighbor, maxIter);
    feature_idx=find(sum(W.^2,2));

    [resmax,resstd] = myResultwithmean(Xall(:,feature_idx(1:FeatureNumber)),Y,C);

    fprintf('ACC:%f NMI:%f\n',resmax(1),resmax(2));
end

