clc;clear;

Root = 'Data';

addpath(genpath('./'));
data={'MSRC-v1'};
dataPath = strcat('./',Root,'/');
name='norm';
maxIter = 20;

funName = 'SMUFS';

fprintf('Training %s\n',funName);


for dataIndex = 1:length(data)
    dataName = strcat(data{dataIndex}); disp(dataName);
    load(strcat(dataPath,dataName));

    C = length(unique(Y));
    viewNumber = length(X);

    totalFeatureNumber=0;
    Xall = [];
    for v = 1:viewNumber
        totalFeatureNumber=totalFeatureNumber+size(X{v},2);
        Xall = [Xall,X{v}];
    end


    %% Parameter setting
    lambda = 1e3;
    gamma = 1e3;
    neighbor = 10;
    FeatureNumber = floor(0.10*totalFeatureNumber);

    %% Training

    fprintf('Now iter:lambda %f gamma %f FeatureNumber %f \n',lambda, gamma, FeatureNumber);
    [W,~] = SMUFS(Xall', U,lambda, gamma, FeatureNumber, neighbor, maxIter);
    feature_idx=find(sum(W.^2,2));

    [resmax,resstd] = myResultwithmean(Xall(:,feature_idx(1:FeatureNumber)),Y,C);

    fprintf('ACC:%f NMI:%f\n',resmax(1),resmax(2));
end



