function [S,eta] = upData_S(U, lambda, k)

    dist_u = L2_distance_1(U',U');
    disth = lambda*dist_u;

    [disth0, idx] = sort(disth,2);      

    n = size(U,1);

    rr = zeros(n,1);
    S = zeros(n,n);

    for i =1:n
        di = disth0(i,2:k+2);
        rr(i) = 0.5*(k*di(k+1)-sum(di(1:k)));
    end

    eta = mean(rr);

    for i = 1:n
        idxa0 = idx(i,2:k+2); 
        du = dist_u(i,idxa0); 
        
        e = lambda*du;

        [e,index] = sort(e);
        idxa0 = idxa0(index);

        S(i,idxa0) = (e(k+1) - e)/(k*e(k+1) - sum(e(1:k)));
    end

end
